
(defun C:SLOT (/ IP P1 P2 P3 P4 WIDTH HEIGHT VL RAD RADTYPE	;define function and declare
		OLDSNAP OLDBLIP OLDLIGHT)								;variables as local

(setq 	OLDSNAP (getvar "OSMODE")			;store system variables
		OLDBLIP (getvar "BLIPMODE")
		OLDLIGHT (getvar "HIGHLIGHT")
);setq
;=========================================
(setvar "CMDECHO" 0)				;change system variables
(setvar "BLIPMODE" 0)
;(setvar "OSMODE" 0)					;switch off snap
(initget 1 "fullRad Filleted")
(setq RADTYPE (getkword "\nSelect System [Full(R)adius/(F)illeted]: "))
(cond 
(
	(= RADTYPE "Filleted") 
	(setq IP (getpoint "\nInsertion Point (slot centre): "))	;get insertion point
	(setq 	WIDTH (getreal "\nEnter WIDTH: ")					;get width of box
			HEIGHT (getreal "\nEnter Height: ")					;get height of box
			RAD (getreal "\nEnter Fillet Radius: ")				;get corner rad
	);setq
	(cond 	((< RAD (/ WIDTH 2) (seteq RAD (/ WIDTH 2))))
			(< RAD (/ HEIGHT 2) (seteq RAD (/ HEIGHT 2))))		;set RAD to maximum size to fit if too large
	(setq VL (sqrt (+ (expt (/ WIDTH 2) 2) (expt (/ HEIGHT 2) 2) )) 	;length of vector line from centre to corner
		P1 (polar IP (atan (/ WIDTH 2) (/ HEIGHT 2)) VL)				;calculate first corner
		P2 (polar IP (atan (/ WIDTH 2) (- (/ HEIGHT 2))) VL)			;calculate second corner
		P3 (polar IP (atan (-(/ WIDTH 2)) (- (/ HEIGHT 2))) VL)			;calculate third corner
		P4 (polar IP (atan (-(/ WIDTH 2)) (/ HEIGHT 2)) VL)				;calculate fourth corner
	);setq
	(command "pline" P4 P1 P2 P3 "CL")									;command to draw the slot
	(command "_.fillet" "_r" RAD "_.fillet" "_polyline" (entlast))		;command to radius the corners
	(prompt "\nRotation Angle: ")										;prompt the user for rotation
	(command "ROTATE" "LAST" "" IP pause)								;rotate the slot
);==============End of filleted slot =====================
(
	(= RADTYPE "Filleted")
	(setq IP (getpoint "\nInsertion Point (slot centre): "))	;get insertion point
	(setq 	WIDTH (getreal "\nEnter WIDTH: ")					;get WIDTH of box
			HEIGHT (getreal "\nEnter Height: ")					;get height of box
	);setq
	(setq VL (sqrt (+ (expt (/ WIDTH 2) 2) (expt (/ HEIGHT 2) 2) )) 	;length of vector line from centre to corner
			P1 (polar IP (atan (/ WIDTH 2) (/ HEIGHT 2)) VL)			;calculate first corner
			P2 (polar IP (atan (/ WIDTH 2) (- (/ HEIGHT 2))) VL)		;calculate second corner
			P3 (polar IP (atan (-(/ WIDTH 2)) (- (/ HEIGHT 2))) VL)		;calculate third corner
			P4 (polar IP (atan (-(/ WIDTH 2)) (/ HEIGHT 2)) VL)			;calculate fourth corner
	);setq
	(command "pline" P4 P1 "A" P2 "L" P3 "A" "CL")					;command to draw the slot with full rad ends
	(prompt "\nRotation Angle: ")										;prompt the user for rotation
	(command "ROTATE" "LAST" "" IP pause)								;rotate the slot
);==============End of Full Rad slot =====================
(t) ) 
;=========================================
(setvar "OSMODE" OLDSNAP)			;reset system variables
(setvar "BLIPMODE" OLDBLIP)
(setvar "HIGHLIGHT" OLDLIGHT)
(princ)								;exit quietly
);defun


